#!/bin/ksh
#
# Component: cases
#
# Description:
#  Forwards DICOM objects in a study to remote DICOM device.
#
#  This is just a wrapper script to call Forward.java
#
# Usage:
#   dcfwd.sh [-u <user>] [-k] -s <studies> -H <hostid>
#
#     -u <user>            : log userid who initiated transmission
#     -s <studies>         : list of Study Instance UIDs of studies to forward
#                            old version used this option only for logging
#     -H <hostid>          : ID of remote device to forward the studies to
#     -k                   : Keep sending updates for the study until is the study is deleted
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

[ -z "$CASES_HOME" ] && . $HOME/etc/setenv.sh


# Prepare arguments to pass to Forward.java
params=""
while [ -n "$1" ] ; do
	if [ "${1#-}" = "$1" ] ; then
		# argument/parameter
		params="$params \"$1\""
	else
		# option
		params="$params $1"
	fi

	shift
done


# Call Forward.java
$TASKD_HOME/runjavacmd -c "0 ${CASES_HOME#$HOME/component/}.Forward${params}" -p $JAVA_SERVER_PORT

exit $?
