/*
 * Component: cases
 *
 * Description:
 *         JavaScript function to be used on EP web pages
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State         		: $State$
 */

// add missing (and missed) string functionality
if ( typeof String.prototype.trim != 'function' ) {
	String.prototype.trim = function() {
		var res = this.replace( /^[\s\xA0]+/, "" ).replace( /[\s\xA0]+$/, "" );
		return res;
	};
}

if ( typeof String.prototype.startsWith != 'function' ) {
	String.prototype.startsWith = function( str ) {
		return this.slice( 0, str.length ) == str;
	};
}

if ( typeof String.prototype.endsWith != 'function' ) {
	String.prototype.endsWith = function( str ) {
		return str.length == 0 || this.slice( -str.length ) == str;
	};
}

// and an array function too
if ( typeof Array.indexOf != 'function' ) {
	Array.prototype.indexOf = function( obj ) {
		for (var i = 0; i < this.length; i++) {
			if ( this[ i ] == obj ) {
				return i;
			}
		}
		return -1;
	};
};

//
function getParameter( param ) {
	var p = document.location.href.indexOf( '?' );
	if ( p < 0 ) {
		return null;
	}
	var params = document.location.href.substr( p + 1 );
	params = new String( params ).split( "&" );
	for (var i = 0; i < params.length; i++) {
		var parStr = new String( params[ i ] );
		if ( parStr.startsWith( param + "=" ) ) {
			return parStr.substr( param.length + 1 );
		}
	}
	return null;
};

function urlEncode( str ) {
	var encodedInputString = escape( str );
	encodedInputString = encodedInputString.replace( /[+]/g, "%2B" );
	encodedInputString = encodedInputString.replace( /[\/]/g, "%2F" );
	return encodedInputString;
};
var agent = navigator.userAgent.toLowerCase();
var is_iphone = agent.indexOf( 'iphone' ) != -1;
var is_ipad = agent.indexOf( 'ipad' ) != -1;
var is_android = agent.indexOf( 'android' ) != -1;
var isWindows = navigator.platform.toUpperCase().indexOf( "WIN" ) != -1;

var ismobile = is_iphone || is_ipad || is_android;// navigator.userAgent.match(
// /(iPad)|(iPhone)|(iPod)|(android)|(webOS)/i
// );

ismobile |= ( "true" == getParameter( "isIphone" ) );

var suffix = ""; // image name-part which distincts big and small images
var jspSuffix = ""; // image name-part which distincts big and small images
var mul = 1; // image size multiplier
var ratio = 1; // window size multiplier

var trick_inputs = new Array(); // array to store the names of hidden inputs
// used to emulate buttons (see
// getInputButton())

/**
 * this function checks for high resolution display and sets variables as needed
 */
function isHiRes() {
	if ( ismobile || self.screen ) {
		if ( ismobile || screen.width * screen.height > 5000000 ) {
			mul = 2;
			suffix = ".big";
			jspSuffix = "&cBig=true";
			ratio = screen.width / 1280;
			return true;
		}
	}
	return false;
};

var hires = isHiRes(); // boolean indicating if the display used is a high
// resolution one

function webViewerChecker() {
	this.wsTxt = -1; // -1 -> not checked, 0 -> OK, 1 -> failed
	this.wsBin = -1;

	this.failed = false;

	this.doFail = function() {
		this.failed = true;
		if ( this.onFailure ) {
			this.onFailure();
		}
	};

	this.startCheck = function() {
		try {
			this.canvas = document.createElement( 'canvas' );
			try {
				if ( !( window.WebGLRenderingContext && ( this.canvas.getContext( 'webgl' ) || this.canvas.getContext( 'experimental-webgl' ) ) ) ) {
					this.doFail();
					return;
				}
			}
			catch ( e ) {
				this.doFail();
				return;
				// we can get a false negative here if FireFox had blacklisted the graphics driver, in this case this can be done:
				//
				// new tab->"about:config"
				// filter for "webgl"
				// double click "webgl.force-enabled" to set it to true.
			}
		}
		catch ( e ) {
			this.doFail();
			return;
		}
		this.onSuccess();
		if ( true )
			return;
		try {
			if ( window.WebSocket ) {
				if ( !jetty_port ) {
					jetty_port = "8081";
				}
				var wsUrl = "ws://" + location.hostname + ":" + jetty_port;
				var _ws = new WebSocket( wsUrl );
				_ws.onmessage = this._onmessage;
				_ws.onerror = this.doFail;
				_ws.send( 't' );
			}
		}
		catch ( e ) {
			this.doFail();
		}
	};

	this._onmessage = function( m ) {
		alert( "onmessage called: " + typeof ( m.data ) );
		if ( m.data ) {
			if ( typeof ( m.data ) == 'string' ) {
				this.wsTxt = 0;
				_ws.send( 'b' );
			}
			else {
				this.wsBin = 0;
			}
			if ( this.wsBin == 0 && this.wsTxt == 0 && this.onSuccess ) {
				this.onSuccess();
			}
		}
		else {
			this.doFail();
		}
	};

};

/**
 * Finds and returns an HTML element by id.
 * 
 * @param id ID of the HTML element to find
 * 
 * @return the HTML element or null
 */
function getelementbyid( id ) {
	if ( document.getElementById )
		return document.getElementById( id );
	else if ( document.all )
		return document.all[ id ];
	else if ( document.layers )
		return document.layers[ id ];
	else
		alert( "Browser not compatible" ); // TODO
};

/**
 * this method will append an object to a node (like a table cell)
 * 
 * @param node the node that the new object will be append to
 * @param href where the new link should point to
 * @param onmouseover what should be the object's onmouseover function
 */
function writeLink( node, href, onmouseover ) {
	var obj = document.createElement( "a" );
	obj.href = href;
	if ( onmouseover ) {
		obj.onmouseover = onmouseover;
	}
	// nobjHeaderNavCloseLink.onclick = function() { myLightbox.end(); return
	// false; }
	node.appendChild( obj );
	return node.lastChild;
};

/**
 * this method will append an object to a node (like a table cell)
 * 
 * @param node the node that the new object will be append to
 * @param href where the new link should point to
 * @param onmouseover what should be the object's onmouseover function
 */
function writeHiddenInput( parentID, name, value ) {
	var obj = document.createElement( "input" );
	obj.type = "hidden";
	obj.name = name;
	obj.value = value;
	node = getelementbyid( parentID );
	node.appendChild( obj );
};

/**
 * creates an image tag to be added to the document
 * 
 * @param img the image name(with path)
 * @param width width of the image (discarded if less than zero)
 * @param height height of the image (discarded if less than zero)
 * @param params string containing any extra parameters for the image
 */
function getImageTag( img, width, height, params ) {
	if ( !params ) {
		params = "";
	}
	var widthStr = "";
	if ( width > 0 ) {
		widthStr = " width=" + width;
	}
	var heightStr = "";
	if ( height > 0 ) {
		heightStr = " height=" + height;
	}
	return "<img SRC=\"" + img + "\"" + widthStr + heightStr + params + ">";
};

/**
 * this writes into the document an image tag
 * 
 * @param img the image name(with path)
 * @param width width of the image (discarded if less than zero)
 * @param height height of the image (discarded if less than zero)
 * @param params string containing any extra parameters for the image
 */
function writeImage( img, width, height, params ) {
	document.writeln( getImageTag( img, width, height, params ) );
};

/**
 * this writes into the given node an image tag
 * 
 * @param node the node that the new object will be append to
 * @param img the image name(with path)
 * @param width width of the image (discarded if less than zero)
 * @param height height of the image (discarded if less than zero)
 * @param alt alt text for the image
 */
function writeImage2node( node, img, width, height, alt ) {
	if ( !alt ) {
		alt = "";
	}
	var nimg = document.createElement( "img" );
	nimg.src = img;
	nimg.border = 0;
	nimg.hspace = 1;
	if ( width ) {
		nimg.width = width;
	}
	if ( height ) {
		nimg.height = height;
	}
	if ( alt ) {
		nimg.alt = alt;
		nimg.title = alt;
	}
	// node = getelementbyid(node);
	node.appendChild( nimg );
};

function writeDynamicButton( label, alt, params, disabled ) {
	document.write( "<img src='/art/buttonize.jsp?cLabel=" + label + ( disabled ? "&cDisabled=true" : "" ) + jspSuffix + "' title='" + protect( alt ) + "' alt='" + protect( alt ) + "'" + params + ">" );
}

function createDynamicButton( label, title, disabled ) {
	var src = "/art/buttonize.jsp?cLocalizedLabel=" + label + ( disabled ? "&cDisabled=true" : "" ) + jspSuffix;
	var res = document.createElement( "img" );
	res.src = src;
	if ( title ) {
		res.title = title;
	}
	return res;
}

/**
 * this writes Image type input field after adjusting parameters depending on "hires" important restrictions: - the containing html page mustn't contain another control element with this name - value mustn't be "null" (the string whose length is 4, 2nd letter is 'u', etc... :) )
 * 
 * @param img the image name(with path defaulting to /art/b/)
 * @param name name of the input field
 * @param value value of the input field
 */
function getInputButton( img, name, value, alt ) {
	var altPart = "";
	if ( alt ) {
		altPart = " alt=\"" + protect( alt ) + "\" title=\"" + protect( alt ) + "\"";
	}
	var ext = img.endsWith( ".png" ) ? ".png" : ".gif";
	var p = img.indexOf( ext );
	var fname = img;
	if ( p >= 0 ) {
		fname = img.substring( 0, p );
	}
	fname = fname + suffix + ext;
	p = img.indexOf( "/" );
	if ( p < 0 ) {
		fname = "/art/b/" + fname;
	}
	if ( name.length == 0 ) {// no parameter to pass by this button
		var html = "<input type=\"image\" src=\"" + fname + "\"" + altPart;
		document.write( html + ">" );
	}
	else {
		trick_inputs[ trick_inputs.length ] = name;
		var html = "<input type=\"hidden\" name=\"" + name + "\" value=\"" + value + "\">" + "<a href=\"javascript: submitTricky(\'" + name + "\', \'" + value + "\');\">" + "<img src=\"" + fname + "\"" + altPart + "></a>";
		document.write( html );
	}
};

/**
 * this writes Image type input field after adjusting parameters depending on "hires" important restrictions: - the containing html page mustn't contain another control element with this name - value mustn't be "null" (the string whose length is 4, 2nd letter is 'u', etc... :) )
 * 
 * @param label the label for the button (got from the resource file)
 * @param name name of the input field
 * @param value value of the input field
 */
function getInputLocalizedButton( label, name, value, alt ) {
	var altPart = "";
	if ( alt ) {
		altPart = " alt=\"" + protect( alt ) + "\" title=\"" + protect( alt ) + "\"";
	}
	img = "/art/buttonize.jsp?cLabel=" + label + jspSuffix;

	if ( name.length == 0 ) {// no parameter to pass by this button
		var html = "<input type=\"image\" src=\"" + img + "\"";
		document.write( html + ">" );
	}
	else {
		trick_inputs[ trick_inputs.length ] = name;
		var html = "<input type=\"hidden\" name=\"" + name + "\" value=\"" + value + "\">" + "<a href=\"javascript: submitTricky(\'" + name + "\', \'" + value + "\');\">" + "<img src=\"" + img + "\"" + altPart + "></a>";
		document.write( html );
	}
};

function submitTricky( selected, value ) {
	var form2Submit = null;
	var debugStr = "clearTricks:\n";
	debugStr += "        searching forms:" + document.forms.length + "\n";
	for (var i = 0; i < document.forms.length; i++) {
		var form = document.forms[ i ];
		debugStr += "        form: " + form + "\n";
		debugStr += "                searching elements:" + form.elements + "\n";
		for (var j = 0; j < form.elements.length; j++) {
			var element = form.elements[ j ];
			if ( element.name == selected ) {
				element.disabled = false;
				element.value = value;
				debugStr += "                element: " + element.name;
				debugStr += " -> turning on.\n";
				form2Submit = form;
			}
			else {
				for (var k = 0; k < trick_inputs.length; k++) {
					if ( trick_inputs[ k ] == element.name ) {
						element.disabled = true;
						element.value = "null";
						debugStr += "                element: " + element.name;
						debugStr += " -> turning off.\n";
					}
				}
			}
		}
	}
	debugStr += "END.";
	// alert(debugStr);
	if ( form2Submit != null ) {
		form2Submit.submit();
	}
};



/**
 * this calles writeImage after adjusting parameters depending on "hires"
 * 
 * @param img the image name(with path defaulting to /cases/art/)
 * @param width width of the image (discarded if less than zero)
 * @param height height of the image (discarded if less than zero)
 * @param params string containing any extra parameters for the image
 */
function getImage( img, width, height, params ) {
	var ext = img.endsWith( ".png" ) ? ".png" : ".gif";
	var p = img.indexOf( ext );
	var fname = img;
	if ( p >= 0 ) {
		fname = img.substring( 0, p );
	}
	fname = fname + suffix + ext;
	p = img.indexOf( "/" );
	if ( p < 0 ) {
		fname = "/cases/art/" + fname;
	}
	if ( width ) {
		var width2 = width * mul;
		var height2 = height * mul;
		writeImage( fname, width2, height2, params );
	}
	else if ( params ) {
		writeImage( fname, 0, 0, params );
	}
	else {
		writeImage( fname );
	}
};

function protect( string ) {
	var result = "";
	for (var i = 0; i < string.length; i++) {
		c = string.charAt( i );
		if ( c == '"' ) {
			result = result + "'";
		}
		else {
			result = result + c;
		}
	}
	return result;
};

function getLinkImage2Node( node, link, onMouseOver, img, width, height, alt ) {
	if ( node ) {
		var linknode = writeLink( node, link, onMouseOver );
		getImage2node( linknode, img, width, height, alt );
	}
	else {
		document.write( "<a href=\"" + protect( link ) + "\"" );
		if ( onMouseOver ) {
			document.write( " onMouseOver=\"" + protect( onMouseOver ) + "\"" );
		}
		document.write( ">" );
		getImage2node( false, img, width, height, alt );
		document.write( "</a>\n" );
	}
};

function addHiddenInput2Node( node, name, value ) {
	if ( node ) {
		var obj = document.createElement( "div" );
		obj.style.display = "none";
		node.appendChild( obj );
		div = node.lastChild;
		var obj2 = document.createElement( "input" );
		obj2.type = "hidden";
		obj2.name = name;
		obj2.id = name;
		obj2.value = value;
		div.appendChild( obj2 );
	}
	else {
		document.write( "<div style=\"display: none\">" );
		document.write( "<input type=hidden name=\"" + name + "\" id=\"" + name + "\" value=\"" + value + "\">" );
		document.write( "</div>\n" );
	}
};

/**
 * this is the node-related version of getImage
 * 
 * @param node the node that the new object will be append to
 * @param img the image name(with path defaulting to /cases/art/)
 * @param width width of the image (discarded if less than zero)
 * @param height height of the image (discarded if less than zero)
 * @param alt string containing alt for the image
 */
function getImage2node( node, img, width, height, alt ) {
	if ( !node ) {
		getImage( img, width, height, " alt=\"" + protect( alt ) + "\" title=\"" + protect( alt ) + "\"" );
		return;
	}
	var ext = img.endsWith( ".png" ) ? ".png" : ".gif";
	var p = img.indexOf( ext );
	var fname = img;
	if ( p >= 0 ) {
		fname = img.substring( 0, p );
	}
	fname = fname + suffix + ext;
	p = img.indexOf( "/" );
	if ( p < 0 ) {
		fname = "/cases/art/" + fname;
	}
	if ( width ) {
		var width2 = width * mul;
		var height2 = height * mul;
		writeImage2node( node, fname, width2, height2, alt );
	}
	else {
		writeImage2node( node, fname, false, false, alt );
	}
};

/**
 * this calles getImageTag after adjusting parameters depending on "hires"
 * 
 * @param img the image name(with path defaulting to /art/b/)
 * @param params string containing any extra parameters for the image
 */
function getButtonTag( img, params ) {
	return getButtonTagFull( img, 91, 18, params );
};

/**
 * this calles getImageTag after adjusting parameters depending on "hires"
 * 
 * @param img the image name(with path defaulting to /art/b/)
 * @param width width of the button (discarded if less than zero)
 * @param height height of the button (discarded if less than zero)
 * @param params string containing any extra parameters for the image
 */
function getButtonTagFull( img, width, height, params ) {
	var width2 = width * mul;
	var height2 = height * mul;
	var ext = img.endsWith( ".png" ) ? ".png" : ".gif";
	var p = img.indexOf( ext );
	var fname = img;
	if ( p >= 0 ) {
		fname = img.substring( 0, p );
	}
	fname = fname + suffix + ext;
	p = img.indexOf( "/" );
	if ( p < 0 ) {
		fname = "/art/b/" + fname;
	}
	return getImageTag( fname, width2, height2, params );
};

/**
 * this calles writeImage after adjusting parameters depending on "hires"
 * 
 * @param img the image name(with path defaulting to /art/b/)
 * @param params string containing any extra parameters for the image
 */
function getButton( img, params ) {
	document.write( getButtonTag( img, params ) );
};

/**
 * Adds image to a div or other HTML element without calling document.write
 * 
 * @param img the button name(with path defaulting to /art/b/)
 * @param width width of the button (discarded if less than zero)
 * @param height height of the button (discarded if less than zero)
 * @param params string containing any extra parameters for the image
 */
function addButtonFullTo( id, img, width, height, params ) {
	var elem = document.getElementById( id );
	if ( elem ) {
		elem.innerHTML += getButtonTagFull( img, width, height, params );
	}
}

/**
 * this calles writeImage after adjusting parameters depending on "hires"
 * 
 * @param img the button name(with path defaulting to /art/b/)
 * @param width width of the button (discarded if less than zero)
 * @param height height of the button (discarded if less than zero)
 * @param params string containing any extra parameters for the image
 */
function getButtonFull( img, width, height, params ) {
	document.write( getButtonTagFull( img, width, height, params ) );
};

function redirPage_b( url ) {
	url2 = url + backParam;
	top.location = url2;
};

function redirPage_prior( par1 ) {
	url2 = '../prior/index.jsp?cStudy=' + par1 + relevParam + backParam;
	top.location = url2;
};

function redirPage_prior2( par1 ) {
	redirPage_prior( par1 + '&cOpenSingle=true' );
};

function redirPage_prior3( par1 ) {
	redirPage_prior( par1 + '&cLocalOnly=true' + '&cOpenSingle=true' );
};

function redirPage_eQV( url ) {
	url2 = 'index.jsp?cQV=' + url + eQVParam;
	top.location = url2;
};

function redirPage_edit( par1, par2 ) {
	redirPage_b( '/cases/edit.jsp?cStudy=' + par1 + '&cIMLockID=' + par2 );
};

function redirPage_editOnOwner( par0, par1, par2, par3, par4 ) {
	redirPage_b( par0 + '/cases/edit.jsp?cStudy=' + par1 + '&cIMLockID=' + par2 + '&ParentSession=' + par3 + '&RefererHost=' + escape( par4 ) );
};

function redirPage_editInScheduler( par1 ) {
	redirPage_b( '/scheduler/orders.jsp?cOp=Edit&c0ZID=' + par1 );
};

function redirPage_cancelInScheduler( par1 ) {
	redirPage_b( '/scheduler/orders.jsp?cOp=Cancel&c0ZID=' + par1 );
};

function redirPage_forward( par1, par2 ) {
	var url = 'forward.jsp?cGr=' + par2;
	if ( par1 != '' )
		url += url + "&cOp=" + par1;
	redirPage_b( url );
};

/*
 * Removed, because it's not used
 * If needed, it should handle /GetPbs/ as well
function redirPage_oper( par1, par2 ) {
	redirPage_b( 'oper.jsp?cInstr=' + par1 + '&cGr=' + par2 );
};
 */

// we must give the fields (same as default fields + Study UID) so the default list don't interrupt
function redirPage_tasks( par1 ) {
	redirPage_b( '/imadmin/jobs.jsp?cFields="1JID%0A1JNA%0A1QUE%0A1SNO%0A1TNO%0A1PRI%0A1RPR%0A1DAT%0A1PST%0APANM%0APAID%0AACCN%0ASYDT%0ADSCR"&qf_1QUE="*Running*";"*Scheduled*";"*Retry*"&qf_1PST=' + par1 );
};

function redirPage_detach( par1 ) {
	redirPage_b( '/cases/detach.jsp?cStudy=' + par1 );
};

function redirPage_detachOnOwner( par0, par1, par2, par3 ) {
	redirPage_b( par0 + '/cases/detach.jsp?cStudy=' + par1 + '&ParentSession=' + par2 + '&RefererHost=' + escape( par3 ) );
};

function redirPage_casesForward( par1 ) {
	redirPage_b( '../cases/forward.jsp?cGr=' + par1 );
};

function redirPage_delete( par1 ) {
	redirPage_b( 'delete.jsp?cGr=' + par1 );
};

function redirPage_eP( url ) {
	url2 = url + "&cContext=" + pageContext;// ePParam;
	document.location = url2;
};

function redirPage_eSP( url ) {
	url2 = sortParams + url;
	document.location = url2;
};

function redirPage_Exp( url ) {
	url2 = expandParams + url;
	top.location = url2;
};

function getSTYIUID( rowNum ) {
	eval( "_res = rowId_" + rowNum );
	return _res;
};

function isInRange( study, main, childCount ) {
	for (var j = main; j < main + childCount + 1; j++) {
		if ( getSTYIUID( j ) == study ) {
			return true;
		}
	}
	return false;
};

function redirPage_expPBS( main, isGetPbsServlet ) {
	childCount = 0;
	while ( expArray[ main + childCount + 1 ] ) {
		childCount++;
	}
	url = "";
	mainAdded = false;
	for (var i = 0; i < self.document.Batch.length; i++) {
		if ( self.document.Batch.elements[ i ].name == 'cGr' && isInRange( self.document.Batch.elements[ i ].value, main, childCount ) ) {
			if ( self.document.Batch.elements[ i ].checked ) {
				syui = self.document.Batch.elements[ i ].value;
				try {
					key = getelementbyid( "cKey_" + syui ).value;
					url = url + '&cGr=' + escape( syui );
					if ( key ) {
						url = url + '&cKey_' + escape( syui ) + "=" + escape( key );
					}
				}
				catch ( e ) {
					// no key node means not openable study, we simply skip it.
				}
			}
			if ( !mainAdded && isInRange( self.document.Batch.elements[ i ].value, main, 0 ) ) {
				url = 'cExpMain=' + escape( self.document.Batch.elements[ i ].value ) + url;
				mainAdded = true;
			}
		}
	}
	if ( isGetPbsServlet ) {
		url2 = '../GetPbs/' + ( new Date() ).getTime() + '.pbs?' + url + PBSParam;
	}
	else {
		url2 = 'getpbs.jsp?' + url + PBSParam;
	}
	top.location = url2;
};

function redirPage_PBS( url, isGetPbsServlet ) {
	if ( isGetPbsServlet ) {
		url2 = '../GetPbs/' + ( new Date() ).getTime() + '.pbs?cGr=' + url + PBSParam;
	}
	else {
		url2 = 'getpbs.jsp?cGr=' + url + PBSParam;
	}
	top.location = url2;
};

function redirPage_MHUB( par1 ) {
	redirPage_b( '/dotcom/parseStudyData.jsp?cStudy=' + par1 );
};

function ws( name ) {
	window.status = name;
};

function wsf( name ) {
	window.status = 'Filter on ' + name;
};

function wsfc( name ) {
	window.status = 'Change filter on ' + name;
};

function wso( name ) {
	window.status = 'Order on ' + name;
};

function wsro() {
	window.status = 'Reverse sort order';
};

function isExpanded() {
	try {
		if ( expArray ) {
			return true;
		}
	}
	catch ( akarmi ) {}
	return false;
};

var goeArray = new Array()
function groupOpenEnforced( rowNum, enforce ) {
	if ( enforce ) {
		goeArray[ rowNum ] = true;
	}
	return goeArray[ rowNum ] ? true : false;
};

/**
 * This function writes action buttons depending on rights (used by ComboAction in Worklist)
 * 
 * Supported rights: 'o' : Open 'q' : Quick View 'e' : Edit 'd' : Delete 'f' : Forward 'p' : Prior 'c' : Copy 'l' : Lock Indicator Light
 * 
 * @param node ID of the table cell the buttons to be written to
 * @param syui Study Instance UID of the current study
 * @param rights String containing characters representing user rights
 * @param dispnam Patient's name in a displayable format
 * @param rowNum Row number of the current row in the table
 * @param nimg Number of images in the study
 * @param nSrc Number of sources (for handling the case when study exists on multiple HUB servers)
 * @param deletable Indicates whether the study is deletable
 * @param editable Indicates whether the study is editable
 * @param locker Name of the user locking the study
 * @param isLockKnown Indicates whether lock status is known or not
 * @param needRedirect Indicates whether certain operations need to be redirected to a HUB server
 * @param redirectHost Host name of HUB server where certain operations need to be redirected
 * @param serverName Server name of current server (to be passed in redirection)
 * @param sid Session ID of current login session (to be passed in redirection)
 * @param isChanged Indicates whether the study has been changed since have been reported
 * @param ownlock Indicates that the study is locked by the current user
 * @param orderNum Scheduler Order Number - edit and delete link should point to the scheduler
 * @param isShortcut Indicates whether the study is a shortcut
 * @param folder Folder the study resides in
 * @param strNotLocked Localized text: Not Locked
 * @param strLockedByYou Localized text: Locked by you
 * @param strLockedBy Localized text: Locked by
 * @param strOpenGroup Localized text: Open group
 * @param strQuickView Localized text: Quick View
 * @param strOpenPatientFolder Localized text: Open patient folder
 * @param strEdit Localized text: Edit
 * @param strOpen Localized text: Open
 * @param strCancel Localized text: Cancel
 * @param strDelete Localized text: Delete
 * @param strForwardExport Localized text: Forward/Export
 * @param strPriorStudiesFor Localized text: Prior studies for
 * @param strMakeCopyFromShortcut Localized text: Make a copy from shortcut to
 * @param strStudyExistsMultipleHubServers Localized text: Study exists on multiple HUB servers
 * @param strEditOnOwnerDevice Localized text: Edit on the owner device
 * @param strDetachShortcutOf Localized text: Detach shortcut of
 */
// function comboWrite2Node( node, syui, key, rights, dispnam, rowNum, nimg, nSrc, deletable, editable, locker, isLockKnown, needRedirect, redirectHost, serverName, serverID, sid, isChanged, ownlock, orderNum, isShortcut, folder ) {
function comboWrite2Node( params ) {
	var syui = params.syui;
	try {
		syui = getSTYIUID( params.rowNum );
	}
	catch ( e ) {}

	var node = null;
	if ( params.node ) {
		node = getelementbyid( params.node );
	}
	var folderTag = '';
	if ( params.folder ) {
		folderTag = '&cFolder=' + encodeURIComponent(params.folder);
	}
	if ( params.rights.indexOf( "l" ) > -1 ) {
		if ( params.editable ) {
			if ( params.isLockKnown ) {
				if ( params.locker ) { // is locked
					if ( params.ownlock ) { // locked by self
						getImage2node( node, "semOwn", 10, 20, params.strLockedByYou );
					}
					else { // locked by someone else
						getImage2node( node, "semLocked", 10, 20, params.strLockedBy + " " + params.locker );
					}
				}
				else { // not locked
					getImage2node( node, "semUnlocked", 10, 20, params.strNotLocked );
				}
			}
			else {
				getImage2node( node, "semUnknown", 10, 20, params.strNotLocked );
			}
		}
		else { // not lockable
			getImage2node( node, "semNotLockable", 10, 20, "" );
		}
	}
	if ( params.nimg > 0 ) {
		if ( params.rights.indexOf( "o" ) > -1 && ( isWindows || ismobile ) ) {
			if ( params.key ) {
				addHiddenInput2Node( node, "cKey_" + syui, params.key );
			}
			if ( isExpanded() ) {
				if ( expArray[ params.rowNum ] ) {
					getImage2node( node, "spacer", 21, 20 );
				}
				else {
					var link = "JavaScript: redirPage_expPBS(" + params.rowNum + "," + params.isGetPbsServlet + ")";
					var onMouseOver = "ws(\"" + params.strOpenGroup + "\"); return true;";
					getLinkImage2Node( node, link, onMouseOver, "batchopen", 21, 20, params.strOpenGroup );
				}
			}
			keyTag = "";
			if ( params.key ) {
				keyTag = "&cKey=" + escape( params.key );
			}
			var link = "JavaScript: redirPage_PBS(\"" + syui + keyTag + folderTag + "\"," + params.isGetPbsServlet + " )";
			if ( ismobile ) {
				link = "eradv" + ( document.location.href.toLowerCase().startsWith( "https" ) ? "s" : "" ) + ":";
				var p0 = document.location.href.indexOf( '//' );
				var p = document.location.href.indexOf( '/', 9 );
				link += document.location.href.substring( p0, p );
				link += "/cases/describeStudy.jsp?sessionid=" + params.sid + "&cStudy=" + syui + "&cBack=" + urlEncode( document.location.href );
			}
			if ( params.isChanged ) {
				getLinkImage2Node( node, link, false, "open.r", 21, 20, params.strOpen + " " + params.dispnam );
			}
			else {
				getLinkImage2Node( node, link, false, "open", 21, 20, params.strOpen + " " + params.dispnam );
			}
		}
		else { // add webViewer open button
			getLinkImage2Node( node, "/EPVWeb/EPVWeb.jsp?cStudy=" + syui + "&cBack=" + urlEncode( document.location.href ) + "#studyview", false, "openbrowserviewer.png", 0, 0, params.strOpen + " " + params.dispnam );
		}
	}
	else {
		if ( params.rights.indexOf( "o" ) > -1 && ( isWindows || ismobile ) ) {
			if ( isExpanded() ) {
				if ( groupOpenEnforced( params.rowNum, params.enforceGroupOpen ) ) {
					var link = "JavaScript: redirPage_expPBS(" + params.rowNum + "," + params.isGetPbsServlet + ")";
					var onMouseOver = "ws(\"" + params.strOpenGroup + "\"); return true;";
					getLinkImage2Node( node, link, onMouseOver, "batchopen", 21, 20, params.strOpenGroup );
				}
				else {
					getImage2node( node, "spacer", 21, 20 );
				}
			}
			getImage2node( node, "spacer", 21, 20 );
		}
		else {
			getImage2node( node, "spacer", 18, 20 );
		}
	}
	if ( params.rights.indexOf( "q" ) > -1 ) {
		getLinkImage2Node( node, "JavaScript: redirPage_eQV(\"" + syui + "\")", "ws(\"" + params.strQuickView + " " + params.dispnam + "\"); return true;", "qview", 18, 20, params.strQuickView + " " + params.dispnam );
	}
	getLinkImage2Node( node, "patientFolder.jsp?cStudy=" + syui, "ws(\"" + params.strOpenPatientFolder + " " + params.dispnam + "\"); return true;", "openpatientfolder.png", 21, 20, params.strOpenPatientFolder + " " + params.dispnam );
	if ( params.rights.indexOf( "e" ) > -1 ) {
		if ( params.orderNum != "" ) {
			if ( params.rights.indexOf( "s" ) > -1 ) {
				getLinkImage2Node( node, "JavaScript: redirPage_editInScheduler(\"" + params.orderNum + "\")", "ws(\"" + params.strEdit + " " + params.dispnam + "\"); return true;", "edit", 18, 20, params.strEdit + " " + params.dispnam );
			}
			else {
				getImage2node( node, "spacer", 18, 20 );
			}
		}
		else {
			if ( params.editable ) {
				if ( !params.needRedirect ) {
					getLinkImage2Node( node, "JavaScript: redirPage_edit(\"" + syui + folderTag + "\", \"" + lockid + "\")", "ws(\"" + params.strEdit + " " + params.dispnam + "\"); return true;", "edit", 18, 20, params.strEdit + " " + params.dispnam );
				}
				else {
					getLinkImage2Node( node, "JavaScript: redirPage_editOnOwner(\"" + params.redirectHost + "\", \"" + syui + folderTag + "\", \"" + lockid + "\", \"" + params.sid + "\", \"" + params.serverName + "\")", "ws(\"" + params.strEditOnOwnerDevice + " " + params.dispnam + "\"); return true;\"", "edit", 18, 20, params.strEdit + " " + params.dispnam );
				}
			}
			else {
				getImage2node( node, "spacer", 18, 20 );
			}
		}
	}
	if ( params.rights.indexOf( "d" ) > -1 ) {
		if ( params.orderNum != "" ) {
			getLinkImage2Node( node, "JavaScript: redirPage_cancelInScheduler(\"" + params.orderNum + "\")", "ws(\"" + params.strCancel + " " + params.dispnam + "\"); return true;", "delete", 18, 20, params.strCancel + " " + params.dispnam );
		}
		else {
			if ( params.deletable ) {
				getLinkImage2Node( node, "JavaScript: redirPage_delete(\"" + syui + folderTag + "\")", "ws(\"" + params.strDelete + " " + params.dispnam + "\"); return true;", "delete", 17, 20, params.strDelete + " " + params.dispnam );
			}
			else {
				getImage2node( node, "spacer", 17, 20 );
			}
		}
	}
	if ( params.rights.indexOf( "f" ) > -1 ) {
		if ( !params.isShortcut && params.nimg > 0 ) {
			getLinkImage2Node( node, "JavaScript: redirPage_forward(\"\",\"" + syui + folderTag + "\")", "ws(\"" + params.strForwardExport + " " + params.dispnam + "\"); return true;", "forward", 16, 20, params.strForwardExport + " " + params.dispnam );
		}
		else {
			getImage2node( node, "spacer", 16, 20 );
		}
	}
	// See tasks link
	// getLinkImage2Node( node, "JavaScript: redirPage_tasks(\"" + syui + "\")", "ws(\"" + params.strSeeTasks + " " + params.dispnam + "\"); return true;", "shortcut", 18, 20, params.strSeeTasks + " " + params.dispnam );
	if ( params.rights.indexOf( "p" ) > -1 ) {
		getLinkImage2Node( node, "JavaScript: redirPage_prior(\"" + syui + "\")", "ws(\"" + params.strPriorStudiesFor + " " + params.dispnam + "\"); return true", "prior", 17, 20, params.strPriorStudiesFor + " " + params.dispnam );
	}
	if ( params.isShortcut && params.rights.indexOf( "c" ) > -1 ) {
		// Detach Shortcut link
		if ( !params.needRedirect ) {
			getLinkImage2Node( node, "JavaScript: redirPage_detach(\"" + syui + "\")", "ws(\"" + params.strDetachShortcutOf + " " + params.dispnam + "\"); return true;", "shortcut", 18, 20, params.strMakeCopyFromShortcut + " " + params.dispnam );
		}
		else {
			getLinkImage2Node( node, "JavaScript: redirPage_detachOnOwner(\"" + params.redirectHost + "\", \"" + syui + "\", \"" + params.sid + "\", \"" + params.serverName + "\")", "ws(\"" + params.strDetachShortcutOf + " " + params.dispnam + "\"); return true;", "shortcut", 18, 20, params.strMakeCopyFromShortcut + " " + params.dispnam );
		}
	}
	if ( params.nSrc > 1 ) {
		// Study exists on multiple HUB server
		if ( params.rights.indexOf( "a" ) > -1 ) {
			// Admin users will have a link to a correction page
			getLinkImage2Node( node, "JavaScript: redirPage_MHUB(\"" + syui + "\")", "ws(\"" + params.strStudyExistsMultipleHubServers + "\"); return true", "warning", 18, 20, " alt=\"Study exists on multiple HUB servers\"" );
		}
		else {
			getImage2node( node, "warning", 18, 20, params.strStudyExistsMultipleHubServers );
		}
	}
};

/**
 * this function writes action buttons depending on rights (used by ComboAction in "Other lists" list)
 * 
 * @param rights String containing characters representing rights: { 'd' : Delete, 'r' : rename, 'w' : owerwrite, 'o' : indicates that this list overrides a group list}
 * @param listUser owner of the current list
 * @param listName name of the current list
 * @param deletable boolean indicating if this study is deletable
 * @param strDelete Localized text: Delete
 * @param strRename Localized text: Rename
 * @param strOverride Localized text: Override
 */
function comboWriteList( rights, listUser, listName, listNameEnc, deletable, params ) {
	if ( rights.indexOf( "d" ) > -1 ) {
		if ( deletable ) {
			document.write( "<A href= \'JavaScript: Oper_(\"" + listUser + "\",\"" + listNameEnc + "\",\"Delete\")\' onMouseOver=\'ws(\"" + params.strDelete + " " + listName + "\"); return true;\'>" );
			getImage( "delete", 17, 20, " alt=\"" + params.strDelete + " " + listName + "\" title=\"" + params.strDelete + " " + listName + "\"" );
			document.write( "</a>" );
		}
		else {
			getImage( "spacer", 17, 20 );
		}
	}
	if ( rights.indexOf( "r" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Oper_(\"" + listUser + "\",\"" + listNameEnc + "\",\"Rename\")\' onMouseOver=\'ws(\"" + params.strRename + " " + listName + "\"); return true;\'>" );
		getImage( "rename", 17, 20, " alt=\"" + params.strRename + " " + listName + "\" title=\"" + params.strRename + " " + listName + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "w" ) != -1 ) {
		document.write( "<A href= \'JavaScript: Oper_(\"" + listUser + "\",\"" + listNameEnc + "\",\"Override\")\' onMouseOver=\'ws(\"" + params.strRename + " " + listName + "\"); return true;\'>" );
		getImage( "edit", 17, 20, " alt=\"" + params.strOverride + " " + listName + "\" title=\"" + params.strOverride + " " + listName + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "o" ) != -1 ) {
		getImage( "semLocked", 10, 20, " alt=\"" + params.strSemLocked + "\" title=\"" + params.strSemLocked + "\"" );
	}
};

/**
 * this function writes action buttons depending on rights (used by ComboAction in "Folders" list)
 * 
 * @param rights String containing characters representing rights: { 'd' : Delete, 'r' : rename}
 * @param folderUser owner of the current folder
 * @param folderName name of the current folder
 * @param strDelete Localized text: Delete
 * @param strRename Localized text: Rename
 */
function comboWriteFolder( rights, folderUser, folderName, params ) {
	if ( rights.indexOf( "d" ) > -1 ) {
		folderName=encodeURIComponent( folderName);
		document.write( "<A href= \'JavaScript: Oper_(\"" + folderUser + "/" + folderName + "\",\"Delete\")\' onMouseOver=\'ws(\"" + params.strDelete + " " + folderName + "\"); return true;\'>" );
		getImage( "delete", 17, 20, " alt=\"" + params.strDelete + " " + folderName + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "r" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Oper_(\"" + folderUser + "/" + folderName + "\",\"Rename\")\' onMouseOver=\'ws(\"" + params.strRename + " " + folderName + "\"); return true;\'>" );
		getImage( "rename", 17, 20, " alt=\"" + params.strRename + " " + folderName + "\"" );
		document.write( "</a>" );
	}
};

/**
 * this function writes action buttons depending on rights (used by ComboAction in "Tasks" list)
 * 
 * @param rights String containing characters representing rights: {'e' : edit, 'r' : reschedule, 'd' : delete, 's' : suspend}
 * @param filename filename identifying the task
 */
function comboWriteTask( rights, filename ) {
	if ( rights.indexOf( "e" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Oper_(\"" + filename + "\",\"Edit\")\' onMouseOver=\'ws(\"Edit " + filename + "\"); return true;\'>" );
		getImage( "edit", 18, 20, " alt=\"Edit " + filename + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "r" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Oper_(\"" + filename + "\",\"Reschedule\")\' onMouseOver=\'ws(\"Reschedule " + filename + "\"); return true;\'>" );
		getImage( "addtoqueue", 21, 20, " alt=\"Reschedule " + filename + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "d" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Oper_(\"" + filename + "\",\"Delete\")\' onMouseOver=\'ws(\"Delete " + filename + "\"); return true;\'>" );
		getImage( "delete", 17, 20, " alt=\"Delete " + filename + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "s" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Oper_(\"" + filename + "\",\"Suspend\")\' onMouseOver=\'ws(\"Suspend " + filename + "\"); return true;\'>" );
		getImage( "suspend", 18, 20, " alt=\"Suspend " + filename + "\"" );
		document.write( "</a>" );
	}
};

/**
 * this function writes action buttons depending on rights (used by ComboAction in "QR" list)
 * 
 * @param rights String containing characters representing rights: { 'r' : Retrieve, 'm' : Move (send)}
 * @param study String containing the studyUID
 * @param parHost String containing target host parameter
 * @param isPresent "true" means that the study is present locally, so should not be retrieved.
 * @param coming "true" means that the study is already retrieving
 * @param strMove Localized text: Move
 * @param strGet Localized text: Get
 * @param strAgain Localized text: again
 * @param strIsRetrieving Localized text: is retrieving
 */
function comboWriteQR( rights, parHost, study, PANM, isPresent, coming, isAdmin, params ) {
	if ( rights.indexOf( "r" ) > -1 ) {
		if ( isPresent ) {
			getImage( "spacer", 16, 20 );
		}
		else {
			if ( params.strProblem != "" ) {
				getImage( "get.d", 16, 20, " alt=\"" + params.strProblem + "\"    title=\"" + protect( params.strProblem ) + "\"    onMouseOver=\'ws(\"" + params.strProblem + "\"); return true;\'" );
			}
			else if ( coming ) {
				if ( isAdmin ) {
					document.write( "<A href= \'JavaScript:forceRetrieve(\"" + parHost + "\", \"" + study + "\")\' onMouseOver=\'ws(\"" + params.strGet + " " + PANM + " " + params.strAgain + "\"); return true;\'>" );
				}
				getImage( "get.d", 16, 20, " alt=\"" + PANM + " " + params.strIsRetrieving + "\"        onMouseOver=\'ws(\"" + PANM + " " + params.strIsRetrieving + "\"); return true;\'" );
				if ( isAdmin ) {
					document.write( "</a>" );
				}
			}
			else {
				document.write( "<A href= \'/archive/get.jsp?cDevStudy=" + parHost + "+" + study + "\' onMouseOver=\'ws(\"" + params.strGet + " " + PANM + "\"); return true;\'>" );
				getImage( "get", 16, 20, " alt=\"" + params.strGet + " " + PANM + "\"" );
				document.write( "</a>" );
			}
		}
	}
	if ( rights.indexOf( "m" ) > -1 ) {
		if ( params.strProblem != "" ) {
			getImage( "forward.d", 16, 20, " alt=\"" + params.strProblem + "\"   title=\"" + protect( params.strProblem ) + "\"     onMouseOver=\'ws(\"" + params.strProblem + "\"); return true;\'" );
		}
		else {
			document.write( "<A href= \'/qr/retrieve.jsp?cDevStudy=" + parHost + "+" + study + "&cOp=Move\' onMouseOver=\'ws(\"" + params.strMove + " " + PANM + "\"); return true;\'>" );
			getImage( "forward", 16, 20, " alt=\"" + params.strMove + " " + PANM + "\"" );
			document.write( "</a>" );
		}
	}
};

/**
 * this function writes action buttons depending on rights (used by ComboAction in "Archive/Media" list)
 * 
 * @param rights String containing characters representing rights: { 'r' : Retrieve }
 * @param study String containing the studyUID
 * @param isPresent "true" means that the study is present locally, so should not be retrieved.
 * @param strAddTo Localized text: Add to
 * @param strGet Localized text: Get
 */
function comboWriteMedia( rights, study, PANM, isPresent, params ) {
	if ( rights.indexOf( "r" ) > -1 ) {
		if ( isPresent ) {
			document.write( "<A href= \'JavaScript:this.document.getForm.cGr.value=\"" + study + "\";this.document.getForm.submit()\' onMouseOver=\'ws(\"" + params.strAddTo + " " + PANM + "\"); return true;\'>" );
			getImage( "get.d", 16, 20, " alt=\"" + params.strAddTo + " " + PANM + "\" title=\"" + params.strAddTo + " " + PANM + "\"" );
		}
		else {
			document.write( "<A href= \'JavaScript:this.document.getForm.cGr.value=\"" + study + "\";this.document.getForm.submit()\' onMouseOver=\'ws(\"" + params.strGet + " " + PANM + "\"); return true;\'>" );
			getImage( "get", 16, 20, " alt=\"" + params.strGet + " " + PANM + "\" title=\"" + params.strGet + " " + PANM + "\"" );
		}
		document.write( "</a>" );
	}
};

/**
 * @params strViewElementsGroup Localized text: View elements of Group
 */
function comboWriteOrderGrouping( pstyiuid, cBack, params ) {
	if ( pstyiuid ) {
		document.write( "<A href= \'/cases/orderGroupSplit.jsp?cBack=" + cBack + "&cPSTYIUID=" + pstyiuid + "\' onMouseOver=\'ws(\"" + params.strViewElementsGroup + "\"); return true;\'>" );
		getImage( "more", 19, 17, " alt=\"" + params.strViewElementsGroup + "\"" );
		document.write( "</a>" );
	}
	else {
		getImage( "spacer", 19, 17 );
	}
};

/**
 * this function writes Batch action buttons depending on rights (used by ComboAction in Worklist)
 * 
 * @param rights String containing characters representing rights: { 'O' : Open, 'D' : Delete, 'F' : forward, 'M' : merge, 'E' : edit }
 * @params strOpenSelectedStudies Localized text: Open selected studies
 * @params strDeleteSelectedStudies Localized text: Delete selected studies
 * @params strForwardExportSelectedStudies Localized text: Forward/Export selected studies
 * @params strMergeSelectedStudies Localized text: Merge selected studies
 * @oarans strBatchApproveSelectedStudies Localized text: Batch approve selected studies
 * @params strBatchEditSelectedStudies Localized text: Batch edit selected studies
 */
function comboWriteBatch( rights, params ) { // script writing Batch buttons
	if ( rights.indexOf( "O" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Batch_(\"Open\")\' onMouseOver=\'protect( ws(\"" + params.strOpenSelectedStudies + "\") ); return true;\'>" );
		getImage( "batchopen", 21, 20, " alt=\"" + params.strOpenSelectedStudies + "\" title=\"" + params.strOpenSelectedStudies + "\"" );
		document.write( "</a>" );
//		document.write( "<A href= \'JavaScript: Batch_(\"WvOpen\")\' onMouseOver=\'ws(\"" + params.strOpenSelectedStudies + "\"); return true;\'>" );
//		getImage( "openbrowserviewer.png", 18, 20, " alt=\"" + params.strOpenSelectedStudies + "\"" );
//		document.write( "</a>" );
	}
	if ( rights.indexOf( "D" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Batch_(\"Del\")\' onMouseOver=\'ws(\"" + params.strDeleteSelectedStudies + "\"); return true;\'>" );
		getImage( "delete", 17, 20, " alt=\"" + params.strDeleteSelectedStudies + "\" title=\"" + params.strDeleteSelectedStudies + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "F" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Batch_(\"Fwd\")\' onMouseOver=\'ws(\"" + params.strForwardExportSelectedStudies + "\"); return true;\'>" );
		getImage( "forward", 16, 20, " alt=\"" + params.strForwardExportSelectedStudies + "\" title=\"" + params.strForwardExportSelectedStudies + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "M" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Batch_(\"Mrg\")\' onMouseOver=\'ws(\"" + params.strMergeSelectedStudies + "\"); return true;\'>" );
		getImage( "merge", 19, 17, " alt=\"" + params.strMergeSelectedStudies + "\" title=\"" + params.strMergeSelectedStudies + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "R" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Batch_(\"bAp\")\' onMouseOver=\'ws(\"" + params.strBatchApproveSelectedStudies + "\"); return true;\'>" );
		getImage( "batchApprove", 18, 20, " alt=\"" + params.strBatchApproveSelectedStudies + "\" title=\"" + params.strBatchApproveSelectedStudies + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "E" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Batch_(\"bEd\")\' onMouseOver=\'ws(\"" + params.strBatchEditSelectedStudies + "\"); return true;\'>" );
		getImage( "edit", 18, 20, " alt=\"" + params.strBatchEditSelectedStudies + "\" title=\"" + params.strBatchEditSelectedStudies + "\"" );
		document.write( "</a>" );
	}
};

/**
 * this function writes Batch action buttons depending on rights (used by ComboAction in "Other lists" list)
 * 
 * @param rights String containing characters representing rights: { 'D' : Delete, 'C' : compound}
 * @params strDeleteSelectedLists Localized text: Delete selected lists
 * @params strMergeSelectedLists Localized text: Merge selected lists
 */
function comboWriteListBatch( rights, params ) { // script writing Batch buttons
	if ( rights.indexOf( "D" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Batch_(\"BatchDel\")\' onMouseOver=\'ws(\"" + params.strDeleteSelectedLists + "\"); return true;\'>" );
		getImage( "delete", 17, 20, " alt=\"" + params.strDeleteSelectedLists + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "C" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Batch_(\"Compound\")\' onMouseOver=\'ws(\"" + params.strMergeSelectedLists + "\"); return true;\'>" );
		getImage( "merge", 19, 17, " alt=\"" + params.strMergeSelectedLists + "\"" );
		document.write( "</a>" );
	}
};

/**
 * this function writes Batch action buttons depending on rights (used by ComboAction in "Task lists" list)
 * 
 * @param rights String containing characters representing rights: { 'E' : edit, 'R' : Reschedule, 'D' : delete, 'S' : suspend}
 * @params strEditSelectedTasks Localized text: Edit selected tasks
 * @params strScheduleSelectedTasks Localized text: Schedule selected tasks
 * @params strDeleteSelectedTasks Localized text: Delete selected tasks
 * @params strSuspendSelectedTasks Localized text: Suspend selected tasks
 */
function comboWriteTaskBatch( rights, params ) { // script writing Batch buttons
	if ( rights.indexOf( "E" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Batch_(\"BatchEdit\")\' onMouseOver=\'ws(\"" + params.strEditSelectedTasks + "\"); return true;\'>" );
		getImage( "edit", 18, 20, " alt=\"" + params.strEditSelectedTasks + "\" title=\"" + params.strEditSelectedTasks + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "R" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Batch_(\"BatchReschedule\")\' onMouseOver=\'ws(\"" + params.strScheduleSelectedTasks + "\"); return true;\'>" );
		getImage( "addtoqueue", 18, 20, " alt=\"" + params.strScheduleSelectedTasks + "\" title=\"" + params.strScheduleSelectedTasks + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "D" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Batch_(\"BatchDelete\")\' onMouseOver=\'ws(\"" + params.strDeleteSelectedTasks + "\"); return true;\'>" );
		getImage( "delete", 17, 20, " alt=\"" + params.strDeleteSelectedTasks + "\" title=\"" + params.strDeleteSelectedTasks + "\"" );
		document.write( "</a>" );
	}
	if ( rights.indexOf( "S" ) > -1 ) {
		document.write( "<A href= \'JavaScript: Batch_(\"BatchSuspend\")\' onMouseOver=\'ws(\"" + params.strSuspendSelectedTasks + "\"); return true;\'>" );
		getImage( "suspend", 18, 20, " alt=\"" + params.strSuspendSelectedTasks + "\" title=\"" + params.strSuspendSelectedTasks + "\"" );
		document.write( "</a>" );
	}
};

function updateSavForm( changed ) {
	var i;
	var form = document.savForm;
	var l = form.savetype.options[ form.savetype.selectedIndex ].value;
	var user;
	if ( form.cListUser.options ) {
		user = form.cListUser.options[ form.cListUser.selectedIndex ].value;
	}
	else {
		user = form.cListUser.value;
	}
	if ( changed == "name" && l != "new" ) {
		for (i = 0; i < form.savetype.options.length; i++) {
			if ( form.savetype.options[ i ].value == "new" ) {
				form.savetype.selectedIndex = i;
			}
		}
		return;
	}

	if ( changed == "type" ) {
		form.cListName.value = l;
		if ( l == ".archive" ) {
			for (i = 0; i < form.cListUser.options.length; i++) {
				if ( form.cListUser.options[ i ].value == "@system" ) {
					form.cListUser.selectedIndex = i;
				}
			}
		}
		else {
			// if group access, disable all users
			for (i = 0; i < form.cListUser.options.length; i++) {
				if ( l == ".groupaccess" ) {
					if ( form.cListUser.options[ i ].value.startsWith( "#" ) ) {
						form.cListUser.options[ i ].disabled = false;
					}
					else {
						form.cListUser.options[ i ].disabled = true;
					}
				}
				else {
					form.cListUser.options[ i ].disabled = false;
				}
			}
		}
		if ( l == "new" ) {
			form.cListName.focus();
		}
		return;
	}

	if ( changed == "user" && l == ".archive" ) {
		for (i = 0; i < form.savetype.options.length; i++) {
			if ( form.savetype.options[ i ].value == "default" ) {
				form.savetype.selectedIndex = i;
			}
		}
		form.cListName.value = "default";
	}

	// if user is a group, enable, otherwise disable .groupaccess type
	if ( changed == "user" ) {
		for (i = 0; i < form.savetype.options.length; i++) {
			if ( form.savetype.options[ i ].value == ".groupaccess" ) {
				if ( user.startsWith( "#" ) ) {
					form.savetype.options[ i ].disabled = false;
				}
				else {
					form.savetype.options[ i ].disabled = true;
				}
			}
		}
	}
}

/**
 * Shows fly-over box The HTML element will be placed to the given position (top left corner)
 * 
 * @param id ID of the fly over box HTML element to hide
 * @param xpos x coordinate of the top left corner the html element to be placed to
 * @param ypos y coordinate of the top left corner the html element to be placed to
 * @param content Content for the HTML element
 */
function showFOB_F( id, xpos, ypos, content ) {
	try {
		var elem = getelementbyid( id );
		if ( elem.style.display == "" )
			return;
		elem.style.left = xpos;
		elem.style.top = ypos;
		elem.innerHTML = content;
		elem.style.display = "";
	}
	catch ( dontcare ) {}
};

/**
 * Shows fly-over box. The fly-over box will be placed yoffset pixel down and xoffset pixel right to the current mouse position
 * 
 * @param id ID of the fly over box HTML element to hide
 * @param event mouse event triggered showing the HTML element for current mouse position
 * @param content Content for the HTML element
 * @param xoffset x offset relative to current mouse position for the top left corner of the HTML element to show (default: 10 pixels)
 * @param yoffset y offset relative to current mouse position for the top left corner of the HTML element to show (default: 10 pixels)
 */
function showFOB( id, event, content, xoffset, yoffset ) {

	var x = 0;
	var y = 0;
	if ( event.clientX || event.clientY ) {
		x = event.clientX + document.body.scrollLeft;
		y = event.clientY + document.body.scrollTop;
	}
	else if ( typeof event.x == 'undefined' ) {
		x = event.pageX;
		y = event.pageY;
	}
	else {
		x = event.x;
		y = event.y;
	}

	var xo = ( typeof xoffset == 'undefined' ) ? 10 : xoffset;
	var yo = ( typeof yoffset == 'undefined' ) ? 10 : yoffset;

	showFOB_F( id, x + xo, y + yo, content );
};

/**
 * Hides fly-over box
 * 
 * param id ID of the fly over box HTML element to hide
 */
function hideFOB( id ) {
	try {
		getelementbyid( id ).style.display = "none";
	}
	catch ( dontcare ) {}
};

function createFOB( id ) {
	try {
		if ( getelementbyid( id ) ) {
			return;
		}
	}
	catch ( e ) {}
	document.write( "<DIV class=\"fob\" id=\"" + id + "\" style=\"display:none\"></DIV>" );
};

/**
 * Submint the form of 'Stat first' top cell
 */

function doSubmitStat( frm, val ) {
	frm.cStat.value = val;
	frm.submit();
};

/**
 * Calculates top coordinate of a HTML (DOM) element relative to the top left corner of the document. WARNING: It may not work correctly on some browsers.
 * 
 * @param e DOM element
 * @return top coordinate
 */
function calcElementTop( e ) {
	var top = 0;

	if ( e.offsetParent ) {
		top = calcElementTop( e.offsetParent );
	}

	var parentNode = e.parentNode;
	while ( parentNode ) {
		if ( parentNode.scrollLeft ) {
			top -= parentNode.scrollTop;
		}
		if ( parentNode == e.offsetParent ) {
			break;
		}
		parentNode = parentNode.parentNode;
	}

	if ( e.offsetTop )
		return top + e.offsetTop;
	if ( e.clientTop )
		return top + e.clientTop;

	return top;
};

/**
 * Calculates left coordinate of a HTML (DOM) element relative to the top left corner of the document. WARNING: It may not work correctly on some browsers.
 * 
 * @param e DOM element
 * @return left coordinate
 */
function calcElementLeft( e ) {
	var left = 0;

	if ( e.offsetParent ) {
		left = calcElementLeft( e.offsetParent );
	}

	var parentNode = e.parentNode;
	while ( parentNode ) {
		if ( parentNode.scrollLeft ) {
			left -= parentNode.scrollLeft;
		}
		if ( parentNode == e.offsetParent ) {
			break;
		}
		parentNode = parentNode.parentNode;
	}

	if ( e.offsetLeft )
		return left + e.offsetLeft;
	if ( e.clientLeft )
		return left + e.clientLeft;

	return left;
};

function jumpToList( page, select, listPart, dispPart ) {
	sep = "?";
	url = page;
	list = select.options[ select.selectedIndex ].value;
	if ( list != "" ) {
		url += sep + listPart + list;
		sep = "&";
	}
	if ( dispPart != "" ) {
		url += sep + dispPart;
	}
	document.location.href = url;
};

function my_getelementbyid( id ) {
	if ( document.getElementById ) {
		return document.getElementById( id );
	}
	else if ( document.all ) {
		return document.all[ id ];
	}
	else if ( document.layers ) {
		return document.layers[ id ];
	}
	else {
		alert( "Browser not compatible" ); // TODO
	}
};

/*
 * 
 * returns true if user has been changed
 */
function updateLocation( type ) {
	var userField = my_getelementbyid( "reg_user" );
	var userid = userField.value.split( " " ).join( "_" );
	// change spaces to _

	if ( lastUser != userid ) {
		lastUser = userid;
		var url = "/main/locationSelect.jsp?cUser=" + userid;
		if ( type != null && type != undefined ) {
			url += "&cType=" + type;
		}
		$( "#reg_location" ).load( url );
		return true;
	}
	return false;
}


function doImport() {
	var frm = self.document.importForm;
	while (frm.cImportFileName.value != frm.New.value) {
		frm.cImportFileName.value = frm.New.value;
	}
	frm.submit();
}
