function showPreviewImage( img, src, fixWidth ) {
	if ( fixWidth ) {
		style = "height: auto; width: 300px";
	}
	else {
		style = "height: 300px; width: auto";
	}
	showTextualPreview( img, "<img src=\"" + src + "\" style=\"" + style + "\">" );
};

function hidePreviewImage( img ) {
	hideTextualPreview();
};

var textPreviewContent = new Array();

/**
 * @type Element
 */
var textPreviewDiv = null;

/**
 * @returns {Element}
 */
function getTextPreviewDiv() {
	// alert( "getTextPreviewDiv called" );
	try {
		if ( textPreviewDiv == null ) {
			textPreviewDiv = document.createElement( "div" );
			textPreviewDiv.id = "textPreviewDiv";
			textPreviewDiv.style.position = "absolute";
			textPreviewDiv.style.zIndex = "100";
			textPreviewDiv.className = "previewDiv";
			// 
			document.body.appendChild( textPreviewDiv );
		}
	}
	catch ( e ) {
		alert( e );
	}
	// alert( "getTextPreviewDiv returns " + textPreviewDiv );
	return textPreviewDiv;
};

function showTextualPreview2( top, left, right, text, iframeWindow ) {
	if ( iframeWindow != null ) {
		var iframes = document.getElementsByTagName( "iframe" );
		for ( var i = 0; i < iframes.length; i++ ) {
			if ( iframes[ i ].contentWindow != iframeWindow ) {
				continue;
			}
			top += calcElementTop( iframes[ i ] );
			var ifl = calcElementLeft( iframes[ i ] );
			left += ifl;
			right += ifl;
			break;
		}
	}
	try {
		if ( parent.window != window ) {
			parent.showTextualPreview2( top - getScrollPositionY(), left - getScrollPositionX(), right - getScrollPositionX(), text, window );
			return;
		}
	}
	catch ( e ) {}
	var tmp = getTextPreviewDiv();
	tmp.innerHTML = text;
	tmp.style.display = "block";
//	var maxBottom = Math.max( document.body.offsetHeight, window.innerHeight );
	var maxBottom = window.innerHeight + window.pageYOffset;
	if ( top + tmp.clientHeight + 10 > maxBottom ) {
		// bottom - height - border
		top = maxBottom - ( tmp.clientHeight + 10 );
	}
	/**
	 * don't correct left position as it hould hide the source image which is not good
	 */
	var maxRight = document.body.offsetWidth;
	//if ( left + tmp.clientWidth + 10 > maxRight ) {
	//left = maxRight - tmp.clientWidth - 10;
	//}
	if ( top == null ) {
		tmp.style.top = "auto";
		tmp.style.bottom = 0;
	}
	else {
		tmp.style.top = top + 10;
		tmp.style.bottom = "auto";
	}
	if ( left > maxRight - right ) {
		tmp.style.right = maxRight - left + 10;
		tmp.style.left = "auto";
	}
	else {
		tmp.style.left = right + 10;
		tmp.style.right = "auto";
	}
};

function showTextualPreview( img, text ) {
	if ( !text ) {
		text = textPreviewContent[ img.id ];
	}
	var top = calcElementTop( img );
	var left = calcElementLeft( img );
	var right = left + img.offsetWidth;
	showTextualPreview2( top, left, right, text, null );
};

function hideTextualPreview() {
	getTextPreviewDiv().style.display = "none";
	if ( parent.window != window ) {
		try {
			parent.hideTextualPreview();
		}
		catch ( e ) {}
	}
};

function showSrt( study, index, imIframeID ) {
	loadImFrame( imIframeID, "/cases/reportPartView.jsp?cSrcStudy=" + study + "&cIndex=" + index );
};

function getNoteURL( study, noteId ) {
	return "/cases/notes.jsp?study=" + study + "&noteId=" + noteId;
};

function showNote( study, noteId, imIframeID ) {
	loadImFrame( imIframeID, getNoteURL( study, noteId ) );
};

function getPFState() {
	return getActualTimeLineCellID();
};

function setPFState( state ) {
	if ( typeof state == "string" && state.length > 0 ) {
		setActualTimeLineCellID( state );
	}
};
