<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *  Saves changes in a study made by editing/merging the study on a remote dotcom server.
 *  If we are not the owner of the study, the change request will be proxied toward the study owner
 *
 * Parameters:
 *
 *  @param study             Study Instance UID
 *  @param series            Series Instance UID
 *  @param cShortcut         Study Instance UID of shortcut (when editing shortcut or via shortcut)
 *  @param cShortcutMode     Mode for editing shortcut (or via shortcut)
 *  @param unlock            Unlock study after saving report: true (= default), false
 *  @param httpIface         true indicates that the original request was received by the HTTP interface
 *  @param cMode             Save Mode: Merge, Edit (= default)
 *  @param cMModFile         Dcmmod file with non merge order attributes to be copied into
 *                           the study PbR file after merge
 *  @param cEditMode         Soft / Hard edit
 *
 *  @param cCoercionFile     Edit study using coercion rules     
 *
 *  Merge or Edit specific parameters
 *
 * Last Updated     : $Author$
 * Update date/time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@page import="java.util.StringTokenizer"%>
<%@page import="java.util.Vector"%>
<%@page import="java.util.Enumeration"%>
<%@page import="java.util.Properties"%>
<%@page import="imagemed.jsputil.ProxyToolbox"%>
<%@page import="imagemed.imsession.IMEnvBase"%>
<%@page import="imagemed.imsession.IMSession"%>
<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.util.*,imagemed.dcprocessing.*,
			com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl"

%><%
	IMSession is = new IMSession( request, response, out );

	MultipartRequest mp = new MultipartRequest( is, IMEnvBase.getEnv( "TMP" ) );

	String parStudy            = mp.getParameter( "study" );
	String parSeries           = mp.getParameter( "series" );
	String parShortcut         = mp.getParameter( "cShortcut" );
	String parLock             = mp.getParameter( "unlock" );
	String parEditMode         = mp.getParameter( "cEditMode" );
	String parShortcutMode     = mp.getParameter( "cShortcutMode" );
	String parCoercionFile     = mp.getParameter( "cCoercionFile" );

	Syslog logger = new Syslog( "savechanges", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );
	logger.syslog( Syslog.LOG_DEBUG, parStudy + " " + is.COOKIE.getProperty( RequestConsts.COOKIE_SESSION_ID_NAME ) );

	is.bCheckHttpsAndRedirect = false;
	if ( ! ProxyToolbox.init( is, mp, logger ) ) {
		if ( !is.regOK() ) {
			return;
		}
	}

	if ( null == parStudy ) {
		logger.syslog( Syslog.LOG_DEBUG, "Study is null" );
%>FAILED<%return;
	}

	// reg.jspi sets is.regID to null
	if ( is.regID == null )
		is.setRegID( request.getHeader( "IMRegID" ) );
	if ( is.regID == null )
		is.setRegID( request.getParameter( "cRegID" ) );

	if ( null == is.regRights || -1 == is.regRights.indexOf( "E" ) ) {
		logger.syslog( Syslog.LOG_DEBUG, "No Rights" );
		response.setHeader( "IMAuthentication", "norights" );%>FAILED<%
		return;
	}

	if ( ProxyToolbox.checkAndProxy( is, parStudy, mp, false) ) {
		logger.syslog( Syslog.LOG_DEBUG, "checkAndProxy is true" );
		return;
	}

	if ( parCoercionFile != null ) {
		// Edit using coercion file
		StudyCoercer studyCoercer = new StudyCoercer( parCoercionFile );
		Properties rspHeaders = new Properties();
		boolean res = studyCoercer.coerce( is, parStudy, rspHeaders );
		for ( Enumeration<?> e = rspHeaders.propertyNames() ; e.hasMoreElements() ; ) {
			String name = ( String ) e.nextElement();
			response.setHeader( name, rspHeaders. getProperty( name ) );
		}
		out.print( res ? "OK" : "FAILED" );
		return;
	}
	
	
	if ( parLock != null ) {
		if ( is.sessionVariables == null )
			is.sessionVariables = new Properties();
		is.sessionVariables.setProperty( "unlock", parLock );
	}

	if ( "true".equals( request.getParameter( "httpIface" ) ) ) {
		if ( is.sessionVariables == null )
			is.sessionVariables = new Properties();
		is.sessionVariables.setProperty( "httpIface", "true" );
	}

	EditStudy.EditMode editMode = EditStudy.EditMode.DEFAULT;
	if ( "Soft".equals( parEditMode ) ) {
		editMode = EditStudy.EditMode.SOFT;
	}
	else if ( "Hard".equals( parEditMode ) ) {
		editMode = EditStudy.EditMode.HARD;
	}

	Syslog operLogger = new Syslog( "editstudy", 0, IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );
	EditStudy es = null;
	if ( null != parShortcut ) {
		es = new EditStudy( parStudy, parShortcut, EditStudy.ShortcutMode.toEnum( parShortcutMode ), operLogger, editMode );
	}
	else {
		es = new EditStudy( parStudy, parSeries, operLogger, editMode );
	}

	Properties rspHeaders = new Properties();
	Properties result = null;

	if ( "merge".equals( mp.getParameter( "cMode" ) ) ) {
		String mmodfilename = mp.getParameter( "cMModFile" );
		IMProperties prpTags = new IMProperties();
		for ( Enumeration<String> e = mp.getParameterNames(); e.hasMoreElements(); ) {
			String name = e.nextElement();
			if ( name.startsWith( "tag_" ) ) {
				String tag = name.substring( 4 );
				String val = mp.getParameter( name );
				prpTags.setProperty( tag, val );
			}
		}

		String extraMsg = mp.getParameter( "cExtraMsg" );
		result = es.edit( prpTags, extraMsg, is, rspHeaders, mmodfilename, null );

	}
	else { // edit

		String strFields = mp.getParameter( "cEditFields" );
		String fields[] = null;
		try {
			Vector<String> v = new Vector<String>();
			StringTokenizer st = new StringTokenizer( strFields, "\n" );
			while ( st.hasMoreTokens() )
				v.add( st.nextToken() );
			fields = v.toArray( new String[ 0 ] );
		}
		catch ( Throwable th ) {
		}

		result = es.edit( fields, is, rspHeaders );
	}

//  EditStudy();

	if ( null != result ) {
%>OK<%
		if ( true )
			return;
	}
	else {
		for ( Enumeration<?> e = rspHeaders.propertyNames() ; e.hasMoreElements() ; ) {
			String name = ( String ) e.nextElement();
			response.setHeader( name, rspHeaders. getProperty( name ) );
		}
%>FAILED<%
		return;
	}

%>
--%>