#!/bin/sh
#
#  sendquery.sh
#
#  Parameters:
#
#      $1    : url
#      $2    : post data
#
# It seems that nobody uses it
#

. $HOME/etc/setenv.sh

LOGGER="/usr/bin/logger"
TAG="sendquery[$$]"

if [ -z "$2" ] ; then
  $LOGGER -p $LOG_FACILITY.error -t "$TAG" "missing parameter(s)"
  exit 0
fi

[ -f "$CONF/system.rec" ] && . $CONF/system.rec 
[ -z "$CURL_TIMEOUT" ] && CURL_TIMEOUT=150

RESPONSE=`$CURL_HOME/bin/curl --max-time $CURL_TIMEOUT -s --data "$2" "$1"`

[ "$RESPONSE" = "OK" ] && exit 0

$LOGGER -p $LOG_FACILITY.error -t "$TAG" "curl $1 $2 returned with $RESPONSE"

[ "$RESPONSE" = "FAILED" ] && exit -1

exit 1
