#!/bin/sh
. $HOME/etc/setenv.sh

deleteDir="false"
if [ "$1" = "-d" ] ; then
	deleteDir="true"
	shift
fi

dir=$1
shift

. $DICOM_VAR/pb-scp.cfg
 
[ -z "$AE_TITLE" ] && AE_TITLE="$DICOM_AE_TITLE"
[ -z "$PORT" ] && PORT="$DICOM_PORT"
[ -z "$TLS_PORT" ] && TLS_PORT="$DICOM_TLS_PORT"

curdir=`pwd`

#storescuOutput="$TMP/ddimport.$$.storescu.out"
#ddlistOutput="$TMP/ddimport.$$.ddlist.out"

storescuOutput="$dir/storescu.out"
ddlistOutput="$dir/ddlist.out"


cd $dir
#echo forwarding files 
#$CD_HOME/ddlist.sh DICOMDIR $@

for dd in DICOMDIR dicomdir Dicomdir DicomDir; do
  [ -f $dir/$dd ] && break;
done

files=`$CD_HOME/ddlist.sh $dd $@ 2> "${ddlistOutput}"`

$DICOM_HOME/bin/storescu -R -I --remove-acquisition --call $AE_TITLE -aet $AE_TITLE $SERVERIP $PORT $files > "${storescuOutput}"

if [ -s "${storescuOutput}" ] ; then
	awk -vOperLog="${UTILS_HOME}/bin/operlog" -vFS=$'\t' '($1 == "IGNORING" ) { \
		system( OperLog " -l OBJECT -a import -t ddimport -e -s \"" $2 "\" -f \"4:" $3 "\" -f \"LOGINFORMATION:" $4 "\"" );}' "${storescuOutput}"
		
	# don't delete the working directory with the outputs and data in case of problem		
	deleteDir="false"	
fi

if [ -s "${ddlistOutput}" ] ; then
	awk -vOperLog="${UTILS_HOME}/bin/operlog" -vFS=$'\t' '($1 == "OBJECT NOT FOUND" ) { \
		system( OperLog " -l STUDY -a import -t ddimport -e -s \"" $3 "\" -f \"LOGINFORMATION:" $1 " " $2 "\" -f \"USERID:system\"" );}' "${ddlistOutput}"
		
	# don't delete the working directory with the outputs and data in case of problem		
	deleteDir="false"	
fi


if [ "$deleteDir" = "true" ] ; then
	rm -r "$dir"
fi


#rm "${storescuOutput}" 2>/dev/null
#rm "${ddlistOutput}" 2>/dev/null

cd $curdir
                       