package imagemed.layout.validator;

import java.util.*;

import com.erad.pacs.services.usermanager.client.Session;

import imagemed.jsputil.IMAdminToolbox;
import imagemed.util.LocalizedMessage;

public class DefaultldapConfigValidator extends DBValidator {

	private static Set<String> RESERVED_IDS = new HashSet<String>();

	static {
		RESERVED_IDS.add( IMAdminToolbox.AUTH_EP );
		RESERVED_IDS.add( IMAdminToolbox.AUTH_GRP );
		RESERVED_IDS.add( IMAdminToolbox.AUTH_SYS );
	}

	@Override
	protected void preValidate( Session session ) {
		setMandatoryError( "LDID" );
		setMandatoryError( "LDSU" );
	}

	@Override
	public void validate( Session session ) {

		mustBeUnique( session, "LDID", m_ldapConfPage, false );

		if ( RESERVED_IDS.contains( getValue( session, "LDID" ) ) ) {
			m_errors.add( getValue( session, "LDID" ) + " " + LocalizedMessage.getSimpleMessage( "LDAPCONFIGVALIDATOR_ID_RESERVED" ) );
		}

	}

}
